comment~
***********************************************************************

 Name:          DO_CACHE.ASM

 Language:      TASM

 Author:

 Version History:

 Rev              Date                Description
 ----          ------------     ---------------------------------
 Created       Sept 24, 1991    Original
 Edited        Oct   3, 1991    Finished project
 Edited        Mar   6, 1992    Touch-ups

***********************************************************************

   Purpose:     ;program enables Cx486SLC/DLC internal cache

   Inputs:      none

   Called By:   operating system

*************************************************************************
~;end comment

     DOSSEG
     .MODEL  SMALL
     .STACK  200h
     .CODE

Msg_1:
	db      0dh,0ah
	db      'Cx486SLC/DLC Internal Cache Enabled! All memory except 640k to 1M is cacheable!'
	db      0dh,0ah
	db      'DO_CACHE.EXE V1.1 Apr. 1, 1992'
	db      0dh,0ah
	db      '$'

ProgramStart:

	.486P                   ;compile using 486"P"riveledged instructions


	cli                     ;turn off all hw interrupts
;----------- Turn off caching

	MOV     EAX,CR0         ;load machine status word (486 method)
	OR      EAX,40000000H   ;set CD bit to 1 Cache Disable
				;set NW bit to 1 Write-Through disabled
	MOV     CR0,EAX         ;store machine status word
	INVD                    ;Flush cache

;-----------Set up the cacheable ctrl

	mov     al,0c0h         ; index to C0
	out     22h,al

	mov     al,00h          ; set C0
	out     23h,al

;-----------Set up the cacheable region areas

;NCR_1
	mov     al,0c5h         ;set index to NCR_1
	out     22h,al

	mov     al,0ah          ;Set NCR_1 to start at addr A000:0 (640k)
	out     23h,al

	mov     al,0c6h         ;set index to NCR_1
	out     22h,al

	mov     al,06h          ;Set NCR_1 size to 128k ( on 128k boundry )
	out     23h,al

; NCR_2
	mov     al,0c8h         ;set index to NCR_2
	out     22h,al

	mov     al,0ch          ;Set NCR_2 to start at addr C000:0 (768k)
	out     23h,al

	mov     al,0c9h         ;set index to NCR_2
	out     22h,al

	mov     al,07h          ;Set NCR_2 size to 256k ( on 256k boundry )
	out     23h,al

;-------Turn on  caching

	MOV     EBX,CR0         ;load machine status word (486 method)
	AND     EBX,09FFFFFFFh  ;set CD bit to 0 Cache enable
				;set NW bit to 0 Write-Through enabled
	mov     CR0,EBX         ;store machine status word

	sti                     ;enable hw interrupts

;-------display a msg
	mov     ax,seg Msg_1
	mov     ds,ax
	mov     dx,offset Msg_1 ;set msg_1 start
	mov     ah,9h           ;print string function
	int     21h             ;msdos int

;--------return to the OS

	mov     ah,4ch          ;return to dos int
	int     21h             ;
	END     ProgramStart    ;


