comment~
***********************************************************************

 Name:          NO_CACHE.ASM

 Language:      TASM

 Author:

 Version History:

 Rev              Date                Description
 ----          ------------     ---------------------------------
 Created       Sept 24, 1991    Original
 Edited        Oct   3, 1991    Finished project
 Edited        Mar   6, 1992    Touch-ups

***********************************************************************

   Purpose:     ;program disables M5 internal cache; restore cache to
		reset condition

   Inputs:      none

   Called By:   operating system

*************************************************************************
~;end comment


     DOSSEG
     .MODEL  SMALL
     .STACK  200h
     .CODE

Msg_1:
	db      0dh,0ah
	db      'Cx486SLC/DLC Internal Cache Disabled! Memory is not internally cached!'
	db      0dh,0ah
	db      'NO_CACHE.EXE V1.1 Apr. 1, 1992'
	db      0dh,0ah
	db      '$'

ProgramStart:

	.486P                   ;compile using 486 instructions

	cli                     ;turn off all hw interrupts
;----------- Turn off caching

	MOV     EAX,CR0         ;load machine status word (486 method)
	OR      EAX,40000000H   ;set CD bit to 1 Cache Disable
				;set NW bit to 1 Write-Through disabled
	MOV     CR0,EAX         ;store machine status word
	INVD                    ;Flush cache

;-----------Set up the cacheable ctrl

	mov     al,0c0h         ;set index to C0
	out     22h,al

	mov     al,00h          ;set C0
	out     23h,al

	mov     al,0c1h         ;set index to C1
	out     22h,al

	mov     al,00h          ;set C1
	out     23h,al


;-----------Set up the non-cacheable region areas

;-------NCR1
	mov     al,0c4h         ;set index to c4
	out     22h,al

	mov     al,00h          ;set c4
	out     23h,al

	mov     al,0c5h         ;set index to c5
	out     22h,al

	mov     al,00h          ;set c5
	out     23h,al

	mov     al,0c6h         ;set index to c6
	out     22h,al

	mov     al,0Fh          ;set c6
	out     23h,al

;-------NCR2
	mov     al,0c7h         ;set index to c7
	out     22h,al

	mov     al,0            ;set c7
	out     23h,al

	mov     al,0c8h         ;set index to c8
	out     22h,al

	mov     al,00h          ;set c8
	out     23h,al

	mov     al,0c9h         ;set index to c9
	out     22h,al

	mov     al,00h          ;set c9
	out     23h,al

;-------NCR3
	mov     al,0cah         ;set index to ca
	out     22h,al

	mov     al,00h          ;set ca
	out     23h,al

	mov     al,0cbh         ;set index to cb
	out     22h,al

	mov     al,00h          ;set cb
	out     23h,al

	mov     al,0cch         ;set index to cc
	out     22h,al

	mov     al,00h          ;set cc
	out     23h,al

;-------NCR4
	mov     al,0cdh         ;set index to cd
	out     22h,al

	mov     al,00h          ;set cd
	out     23h,al

	mov     al,0ceh         ;set index to ce
	out     22h,al

	mov     al,00h          ;set ce
	out     23h,al

	mov     al,0cfh         ;set index to cf
	out     22h,al

	mov     al,00h          ;set cf
	out     23h,al

;-------Turn on  cacheing

	INVD                    ;flush cache
	MOV     EBX,CR0         ;load machine status word (486 method)
	AND     EBX,09FFFFFFFh  ;set CD bit to 0 Cache enable
				;set NW bit to 0 Write-Through enabled
	mov     CR0,EBX         ;store machine status word

	sti                     ;enable hw interrupts

;-------display a msg
	mov     ax,seg Msg_1
	mov     ds,ax
	mov     dx,offset Msg_1 ;set msg_1 start
	mov     ah,9h           ;print string function
	int     21h             ;msdos int

;-------return to the OS

	mov     ah,4ch          ;return to dos int
	int     21h             ;
	END     ProgramStart    ;

